[Skip to main content](https://docs.gitlab.com/api/cluster_agents/#skipTarget) [Go to GitLab Docs homepage](https://docs.gitlab.com/)
`/`
[What's new?](https://about.gitlab.com/releases/whats-new/)
English
  * Language
  * English
  * 日本語


v18.10
  *     * [18.10 (not yet released)](https://docs.gitlab.com/api/cluster_agents/)
  *     * [18.9 (recently released)](https://docs.gitlab.com/18.9/api/cluster_agents/)
    * [18.8](https://docs.gitlab.com/18.8/api/cluster_agents/)
    * [18.7](https://archives.docs.gitlab.com/18.7/api/cluster_agents/)
  *     * [17.11](https://archives.docs.gitlab.com/17.11/api/cluster_agents/)
    * [16.11](https://archives.docs.gitlab.com/16.11/ee/api/cluster_agents.html)
  *     * [Archives](https://docs.gitlab.com/archives)


Select theme and layout
  * Light mode
  * Dark mode
  * Auto


  * Fixed width
  * Fluid width


[What's new?](https://about.gitlab.com/releases/whats-new/) [Get free trial](https://gitlab.com/-/trial_registrations/new?glm_source=docs.gitlab.com&amp;glm_content=navigation-cta-docs)
Toggle menu
  * [Use GitLab](https://docs.gitlab.com/user/)
  * [GitLab Duo](https://docs.gitlab.com/user/gitlab_duo/)
  * [Extend](https://docs.gitlab.com/api/)
  * [Install](https://docs.gitlab.com/install/)
  * [Administer](https://docs.gitlab.com/administration/)
  * [Subscribe](https://docs.gitlab.com/subscriptions/)
  * [Contribute](https://docs.gitlab.com/development/)
  * [Solutions](https://docs.gitlab.com/solutions/)


Select a topicUse GitLab GitLab Duo Extend Install Administer Subscribe Contribute Solutions
[Getting started](https://docs.gitlab.com/api/get_started/get_started_extending/)
[Tutorials](https://docs.gitlab.com/tutorials/develop/)
[Integrations](https://docs.gitlab.com/integration/)
[Webhooks](https://docs.gitlab.com/user/project/integrations/webhooks/)
[REST API](https://docs.gitlab.com/api/rest/)
[Resources](https://docs.gitlab.com/api/api_resources/)
[.gitignore (templates)](https://docs.gitlab.com/api/templates/gitignores/)
[.gitlab-ci.yml (templates)](https://docs.gitlab.com/api/templates/gitlab_ci_ymls/)
[Access requests](https://docs.gitlab.com/api/access_requests/)
[Agent for Kubernetes](https://docs.gitlab.com/api/cluster_agents/)
[AI Catalog admin](https://docs.gitlab.com/api/admin/ai_catalog/)
[Alert management](https://docs.gitlab.com/api/alert_management_alerts/)
[Application appearance](https://docs.gitlab.com/api/appearance/)
[Application settings](https://docs.gitlab.com/api/settings/)
[Application statistics](https://docs.gitlab.com/api/statistics/)
[Applications](https://docs.gitlab.com/api/applications/)
[Attestations](https://docs.gitlab.com/api/attestations/)
[Audit events](https://docs.gitlab.com/api/audit_events/)
[Avatar](https://docs.gitlab.com/api/avatar/)
[Branches](https://docs.gitlab.com/api/branches/)
[Broadcast messages](https://docs.gitlab.com/api/broadcast_messages/)
[Cluster discovery (certificate-based) (deprecated)](https://docs.gitlab.com/api/cluster_discovery/)
[Code Suggestions](https://docs.gitlab.com/api/code_suggestions/)
[Commits](https://docs.gitlab.com/api/commits/)
[Compliance and policy settings](https://docs.gitlab.com/api/compliance_policy_settings/)
[Composer](https://docs.gitlab.com/api/packages/composer/)
[Conan v1](https://docs.gitlab.com/api/packages/conan_v1/)
[Conan v2](https://docs.gitlab.com/api/packages/conan_v2/)
[Container registry](https://docs.gitlab.com/api/container_registry/)
[Container repository protection rules](https://docs.gitlab.com/api/container_repository_protection_rules/)
[Container registry protection tag rules](https://docs.gitlab.com/api/container_registry_protection_tag_rules/)
[Container virtual registry](https://docs.gitlab.com/api/container_virtual_registries/)
[Custom attributes](https://docs.gitlab.com/api/custom_attributes/)
[Database migrations](https://docs.gitlab.com/api/database_migrations/)
[Data management](https://docs.gitlab.com/api/admin/data_management/)
[Debian](https://docs.gitlab.com/api/packages/debian/)
[Debian group distributions](https://docs.gitlab.com/api/packages/debian_group_distributions/)
[Debian project distributions](https://docs.gitlab.com/api/packages/debian_project_distributions/)
[Dependencies](https://docs.gitlab.com/api/dependencies/)
[Dependency list export](https://docs.gitlab.com/api/dependency_list_export/)
[Dependency Proxy](https://docs.gitlab.com/api/dependency_proxy/)
[Deploy keys](https://docs.gitlab.com/api/deploy_keys/)
[Deploy tokens](https://docs.gitlab.com/api/deploy_tokens/)
[Deployments](https://docs.gitlab.com/api/deployments/)
[Discussions](https://docs.gitlab.com/api/discussions/)
[Dockerfile (templates)](https://docs.gitlab.com/api/templates/dockerfiles/)
[DORA4 metrics](https://docs.gitlab.com/api/dora/metrics/)
[Emoji reactions](https://docs.gitlab.com/api/emoji_reactions/)
[Environments](https://docs.gitlab.com/api/environments/)
[Epics (deprecated)](https://docs.gitlab.com/api/epics/)
[Error tracking](https://docs.gitlab.com/api/error_tracking/)
[Events](https://docs.gitlab.com/api/events/)
[Experiments](https://docs.gitlab.com/api/experiments/)
[External status checks](https://docs.gitlab.com/api/status_checks/)
[Feature flags](https://docs.gitlab.com/api/feature_flags/)
[Feature flag user lists](https://docs.gitlab.com/api/feature_flag_user_lists/)
[Freeze periods](https://docs.gitlab.com/api/freeze_periods/)
[Geo nodes (deprecated)](https://docs.gitlab.com/api/geo_nodes/)
[Geo sites](https://docs.gitlab.com/api/geo_sites/)
[GitLab Duo Chat completions](https://docs.gitlab.com/api/chat/)
[GitLab Pages](https://docs.gitlab.com/api/pages/)
[GLQL](https://docs.gitlab.com/api/glql/)
[Go Proxy](https://docs.gitlab.com/api/packages/go_proxy/)
[Google Cloud integration](https://docs.gitlab.com/api/google_cloud_integration/)
[Groups](https://docs.gitlab.com/api/groups/)
[Helm](https://docs.gitlab.com/api/packages/helm/)
[Import](https://docs.gitlab.com/api/import/)
[Instance CI/CD variables](https://docs.gitlab.com/api/instance_level_ci_variables/)
[Invitations](https://docs.gitlab.com/api/invitations/)
[Issues](https://docs.gitlab.com/api/issues/)
[Issues (epic) (deprecated)](https://docs.gitlab.com/api/epic_issues/)
[Issues statistics](https://docs.gitlab.com/api/issues_statistics/)
[Jobs](https://docs.gitlab.com/api/jobs/)
[Job artifacts](https://docs.gitlab.com/api/job_artifacts/)
[Job token scopes](https://docs.gitlab.com/api/project_job_token_scopes/)
[Keys](https://docs.gitlab.com/api/keys/)
[License](https://docs.gitlab.com/api/license/)
[Licenses (templates)](https://docs.gitlab.com/api/templates/licenses/)
[Linked epics (deprecated)](https://docs.gitlab.com/api/linked_epics/)
[Links (issue)](https://docs.gitlab.com/api/issue_links/)
[Links (epic) (deprecated)](https://docs.gitlab.com/api/epic_links/)
[Lint .gitlab-ci.yml](https://docs.gitlab.com/api/lint/)
[Markdown](https://docs.gitlab.com/api/markdown/)
[Maven](https://docs.gitlab.com/api/packages/maven/)
[Maven virtual registry](https://docs.gitlab.com/api/maven_virtual_registries/)
[Member roles](https://docs.gitlab.com/api/member_roles/)
[Merge request approvals](https://docs.gitlab.com/api/merge_request_approvals/)
[Merge request approval settings](https://docs.gitlab.com/api/merge_request_approval_settings/)
[Merge request context commits](https://docs.gitlab.com/api/merge_request_context_commits/)
[Merge requests](https://docs.gitlab.com/api/merge_requests/)
[Merge trains](https://docs.gitlab.com/api/merge_trains/)
[Metadata](https://docs.gitlab.com/api/metadata/)
[Model registry](https://docs.gitlab.com/api/model_registry/)
[Namespaces](https://docs.gitlab.com/api/namespaces/)
[Notes (comments)](https://docs.gitlab.com/api/notes/)
[Notification settings](https://docs.gitlab.com/api/notification_settings/)
[npm](https://docs.gitlab.com/api/packages/npm/)
[NuGet](https://docs.gitlab.com/api/packages/nuget/)
[Organizations](https://docs.gitlab.com/api/organizations/)
[Packages](https://docs.gitlab.com/api/packages/)
[Pages domains](https://docs.gitlab.com/api/pages_domains/)
[Personal access tokens](https://docs.gitlab.com/api/personal_access_tokens/)
[Pipeline schedules](https://docs.gitlab.com/api/pipeline_schedules/)
[Pipeline trigger tokens](https://docs.gitlab.com/api/pipeline_triggers/)
[Pipelines](https://docs.gitlab.com/api/pipelines/)
[Plan limits](https://docs.gitlab.com/api/plan_limits/)
[Product analytics](https://docs.gitlab.com/api/product_analytics/)
[Projects](https://docs.gitlab.com/api/projects/)
[PyPI](https://docs.gitlab.com/api/packages/pypi/)
[Repositories](https://docs.gitlab.com/api/repositories/)
[Repository files](https://docs.gitlab.com/api/repository_files/)
[Repository submodules](https://docs.gitlab.com/api/repository_submodules/)
[Resource group](https://docs.gitlab.com/api/resource_groups/)
[Resource iteration events](https://docs.gitlab.com/api/resource_iteration_events/)
[Resource label events](https://docs.gitlab.com/api/resource_label_events/)
[Resource milestone events](https://docs.gitlab.com/api/resource_milestone_events/)
[Resource state events](https://docs.gitlab.com/api/resource_state_events/)
[Resource weight events](https://docs.gitlab.com/api/resource_weight_events/)
[Ruby gems](https://docs.gitlab.com/api/packages/rubygems/)
[Runners](https://docs.gitlab.com/api/runners/)
[Runner controllers](https://docs.gitlab.com/api/runner_controllers/)
[Runner controller tokens](https://docs.gitlab.com/api/runner_controller_tokens/)
[Search](https://docs.gitlab.com/api/search/)
[Search migrations](https://docs.gitlab.com/api/search_admin/)
[Secure files](https://docs.gitlab.com/api/secure_files/)
[Service accounts](https://docs.gitlab.com/api/service_accounts/)
[Service Ping](https://docs.gitlab.com/api/usage_data/)
[Sidekiq metrics](https://docs.gitlab.com/api/sidekiq_metrics/)
[Sidekiq queues](https://docs.gitlab.com/api/admin_sidekiq_queues/)
[Snippet repository storage moves](https://docs.gitlab.com/api/snippet_repository_storage_moves/)
[Snippets](https://docs.gitlab.com/api/snippets/)
[Suggestions](https://docs.gitlab.com/api/suggestions/)
[System hooks](https://docs.gitlab.com/api/system_hooks/)
[Tags](https://docs.gitlab.com/api/tags/)
[Terraform registry](https://docs.gitlab.com/api/packages/terraform-modules/)
[To-Do List](https://docs.gitlab.com/api/todos/)
[Token information](https://docs.gitlab.com/api/admin/token/)
[Topics](https://docs.gitlab.com/api/topics/)
[Users](https://docs.gitlab.com/api/users/)
[Version](https://docs.gitlab.com/api/version/)
[Virtual registries cleanup policies](https://docs.gitlab.com/api/virtual_registries_cleanup_policies/)
[Vulnerabilities](https://docs.gitlab.com/api/vulnerabilities/)
[Vulnerability archive export](https://docs.gitlab.com/api/vulnerability_archive_exports/)
[Vulnerability export](https://docs.gitlab.com/api/vulnerability_exports/)
[Vulnerability findings](https://docs.gitlab.com/api/vulnerability_findings/)
[Web commits](https://docs.gitlab.com/api/web_commits/)
[Authentication](https://docs.gitlab.com/api/rest/authentication/)
[Third-party clients](https://docs.gitlab.com/api/rest/third_party_clients/)
[Deprecations and removals](https://docs.gitlab.com/api/rest/deprecations/)
[OpenAPI](https://docs.gitlab.com/api/openapi/openapi_interactive/)
[Automate storage management](https://docs.gitlab.com/user/storage_management_automation/)
[Troubleshooting](https://docs.gitlab.com/api/rest/troubleshooting/)
[GraphQL API](https://docs.gitlab.com/api/graphql/)
[OAuth 2.0 identity provider API](https://docs.gitlab.com/api/oauth2/)
[GitLab Duo CLI (duo)](https://docs.gitlab.com/user/gitlab_duo_cli/)
[GitLab CLI (glab)](https://docs.gitlab.com/cli/)
[Editor and IDE extensions](https://docs.gitlab.com/editor_extensions/)
/
  1. [GitLab Docs](https://docs.gitlab.com/)
  2. [Extend](https://docs.gitlab.com/api/)
  3. [REST API](https://docs.gitlab.com/api/rest/)
  4. [Resources](https://docs.gitlab.com/api/api_resources/)
  5. [Agent for Kubernetes](https://docs.gitlab.com/api/cluster_agents/)


* * *
# Kubernetes agent API
  * Tier: Free, Premium, Ultimate
  * Offering: GitLab.com, GitLab Self-Managed, GitLab Dedicated


History
  * Agent Tokens API [introduced](https://gitlab.com/gitlab-org/gitlab/-/issues/347046) in GitLab 15.0.


Use this API to interact with the [GitLab agent for Kubernetes](https://docs.gitlab.com/user/clusters/agent/).
## List all agents[](https://docs.gitlab.com/api/cluster_agents/#list-all-agents "Permalink")
Lists all agents registered for the project.
You must have the Developer, Maintainer, or Owner role to use this endpoint.
```
GET /projects/:id/cluster_agents
```

Parameters:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user
Response:
The response is a list of agents with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the agent
`name` | string | Name of the agent
`config_project` | object | Object representing the project the agent belongs to
`config_project.id` | integer | ID of the project
`config_project.description` | string | Description of the project
`config_project.name` | string | Name of the project
`config_project.name_with_namespace` | string | Full name with namespace of the project
`config_project.path` | string | Path to the project
`config_project.path_with_namespace` | string | Full path with namespace to the project
`config_project.created_at` | string | ISO8601 datetime when the project was created
`created_at` | string | ISO8601 datetime when the agent was created
`created_by_user_id` | integer | ID of the user who created the agent
Example request:
shell
```
curl \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents"
```

Example response:
json
```
[
  {
    "id": 1,
    "name": "agent-1",
    "config_project": {
      "id": 20,
      "description": "",
      "name": "test",
      "name_with_namespace": "Administrator / test",
      "path": "test",
      "path_with_namespace": "root/test",
      "created_at": "2022-03-20T20:42:40.221Z"
    },
    "created_at": "2022-04-20T20:42:40.221Z",
    "created_by_user_id": 42
  },
  {
    "id": 2,
    "name": "agent-2",
    "config_project": {
      "id": 20,
      "description": "",
      "name": "test",
      "name_with_namespace": "Administrator / test",
      "path": "test",
      "path_with_namespace": "root/test",
      "created_at": "2022-03-20T20:42:40.221Z"
    },
    "created_at": "2022-04-20T20:42:40.221Z",
    "created_by_user_id": 42
  }
]
```

## Retrieve an agent[](https://docs.gitlab.com/api/cluster_agents/#retrieve-an-agent "Permalink")
Retrieves a single agent’s details.
You must have the Developer, Maintainer, or Owner role to use this endpoint.
```
GET /projects/:id/cluster_agents/:agent_id
```

Parameters:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user
`agent_id` | integer | yes | ID of the agent
Response:
The response is a single agent with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the agent
`name` | string | Name of the agent
`config_project` | object | Object representing the project the agent belongs to
`config_project.id` | integer | ID of the project
`config_project.description` | string | Description of the project
`config_project.name` | string | Name of the project
`config_project.name_with_namespace` | string | Full name with namespace of the project
`config_project.path` | string | Path to the project
`config_project.path_with_namespace` | string | Full path with namespace to the project
`config_project.created_at` | string | ISO8601 datetime when the project was created
`created_at` | string | ISO8601 datetime when the agent was created
`created_by_user_id` | integer | ID of the user who created the agent
Example request:
shell
```
curl \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/1"
```

Example response:
json
```
{
  "id": 1,
  "name": "agent-1",
  "config_project": {
    "id": 20,
    "description": "",
    "name": "test",
    "name_with_namespace": "Administrator / test",
    "path": "test",
    "path_with_namespace": "root/test",
    "created_at": "2022-03-20T20:42:40.221Z"
  },
  "created_at": "2022-04-20T20:42:40.221Z",
  "created_by_user_id": 42
}
```

## Create an agent[](https://docs.gitlab.com/api/cluster_agents/#create-an-agent "Permalink")
Creates a new agent for the project.
You must have the Maintainer or Owner role to use this endpoint.
```
POST /projects/:id/cluster_agents
```

Parameters:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user
`name` | string | yes | Name for the agent
Response:
The response is the new agent with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the agent
`name` | string | Name of the agent
`config_project` | object | Object representing the project the agent belongs to
`config_project.id` | integer | ID of the project
`config_project.description` | string | Description of the project
`config_project.name` | string | Name of the project
`config_project.name_with_namespace` | string | Full name with namespace of the project
`config_project.path` | string | Path to the project
`config_project.path_with_namespace` | string | Full path with namespace to the project
`config_project.created_at` | string | ISO8601 datetime when the project was created
`created_at` | string | ISO8601 datetime when the agent was created
`created_by_user_id` | integer | ID of the user who created the agent
Example request:
shell
```
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --header "Content-Type: application/json" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents" \
  --data '{"name":"some-agent"}'
```

Example response:
json
```
{
  "id": 1,
  "name": "agent-1",
  "config_project": {
    "id": 20,
    "description": "",
    "name": "test",
    "name_with_namespace": "Administrator / test",
    "path": "test",
    "path_with_namespace": "root/test",
    "created_at": "2022-03-20T20:42:40.221Z"
  },
  "created_at": "2022-04-20T20:42:40.221Z",
  "created_by_user_id": 42
}
```

## Delete an agent[](https://docs.gitlab.com/api/cluster_agents/#delete-an-agent "Permalink")
Deletes an existing agent registration.
You must have the Maintainer or Owner role to use this endpoint.
```
DELETE /projects/:id/cluster_agents/:agent_id
```

Parameters:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user
`agent_id` | integer | yes | ID of the agent
Example request:
shell
```
curl --request DELETE \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/1"
```

## List all agent tokens[](https://docs.gitlab.com/api/cluster_agents/#list-all-agent-tokens "Permalink")
History
  * [Introduced](https://gitlab.com/gitlab-org/gitlab/-/issues/347046) in GitLab 15.0.


Lists all active tokens for an agent.
You must have the Developer, Maintainer, or Owner role to use this endpoint.
```
GET /projects/:id/cluster_agents/:agent_id/tokens
```

Supported attributes:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user.
`agent_id` | integer or string | yes | ID of the agent.
Response:
The response is a list of tokens with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the token.
`name` | string | Name of the token.
`description` | string or null | Description of the token.
`agent_id` | integer | ID of the agent the token belongs to.
`status` | string | The status of the token. Valid values are `active` and `revoked`.
`created_at` | string | ISO8601 datetime when the token was created.
`created_by_user_id` | string | User ID of the user who created the token.
Example request:
shell
```
curl \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/tokens"
```

Example response:
json
```
[
  {
    "id": 1,
    "name": "abcd",
    "description": "Some token",
    "agent_id": 5,
    "status": "active",
    "created_at": "2022-03-25T14:12:11.497Z",
    "created_by_user_id": 1
  },
  {
    "id": 2,
    "name": "foobar",
    "description": null,
    "agent_id": 5,
    "status": "active",
    "created_at": "2022-03-25T14:12:11.497Z",
    "created_by_user_id": 1
  }
]
```

The `last_used_at` field for a token is only returned when getting a single agent token.
## Retrieve an agent token[](https://docs.gitlab.com/api/cluster_agents/#retrieve-an-agent-token "Permalink")
History
  * [Introduced](https://gitlab.com/gitlab-org/gitlab/-/issues/347046) in GitLab 15.0.


Retrieves a single agent token.
You must have the Developer, Maintainer, or Owner role to use this endpoint.
Returns a `404` if the agent token has been revoked.
```
GET /projects/:id/cluster_agents/:agent_id/tokens/:token_id
```

Supported attributes:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user.
`agent_id` | integer | yes | ID of the agent.
`token_id` | integer | yes | ID of the token.
Response:
The response is a single token with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the token.
`name` | string | Name of the token.
`description` | string or null | Description of the token.
`agent_id` | integer | ID of the agent the token belongs to.
`status` | string | The status of the token. Valid values are `active` and `revoked`.
`created_at` | string | ISO8601 datetime when the token was created.
`created_by_user_id` | string | User ID of the user who created the token.
`last_used_at` | string or null | ISO8601 datetime when the token was last used.
Example request:
shell
```
curl \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/token/1"
```

Example response:
json
```
{
  "id": 1,
  "name": "abcd",
  "description": "Some token",
  "agent_id": 5,
  "status": "active",
  "created_at": "2022-03-25T14:12:11.497Z",
  "created_by_user_id": 1,
  "last_used_at": null
}
```

## Create an agent token[](https://docs.gitlab.com/api/cluster_agents/#create-an-agent-token "Permalink")
History
  * [Introduced](https://gitlab.com/gitlab-org/gitlab/-/issues/347046) in GitLab 15.0.
  * Two-token limit [introduced](https://gitlab.com/gitlab-org/gitlab/-/issues/361030/) in GitLab 16.1 with a [flag](https://docs.gitlab.com/administration/feature_flags/) named `cluster_agents_limit_tokens_created`.
  * Two-token limit [generally available](https://gitlab.com/gitlab-org/gitlab/-/issues/412399) in GitLab 16.2. Feature flag `cluster_agents_limit_tokens_created` removed.


Creates a new token for an agent.
You must have the Maintainer or Owner role to use this endpoint.
An agent can have only two active tokens at one time.
```
POST /projects/:id/cluster_agents/:agent_id/tokens
```

Supported attributes:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user.
`agent_id` | integer | yes | ID of the agent.
`name` | string | yes | Name for the token.
`description` | string | no | Description for the token.
Response:
The response is the new token with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the token.
`name` | string | Name of the token.
`description` | string or null | Description of the token.
`agent_id` | integer | ID of the agent the token belongs to.
`status` | string | The status of the token. Valid values are `active` and `revoked`.
`created_at` | string | ISO8601 datetime when the token was created.
`created_by_user_id` | string | User ID of the user who created the token.
`last_used_at` | string or null | ISO8601 datetime when the token was last used.
`token` | string | The secret token value.
The `token` is only returned in the response of the `POST` endpoint and cannot be retrieved afterwards.
Example request:
shell
```
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --header "Content-Type: application/json" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/tokens" \
  --data '{"name":"some-token"}'
```

Example response:
json
```
{
  "id": 1,
  "name": "abcd",
  "description": "Some token",
  "agent_id": 5,
  "status": "active",
  "created_at": "2022-03-25T14:12:11.497Z",
  "created_by_user_id": 1,
  "last_used_at": null,
  "token": "qeY8UVRisx9y3Loxo1scLxFuRxYcgeX3sxsdrpP_fR3Loq4xyg"
}
```

## Revoke an agent token[](https://docs.gitlab.com/api/cluster_agents/#revoke-an-agent-token "Permalink")
History
  * [Introduced](https://gitlab.com/gitlab-org/gitlab/-/issues/347046) in GitLab 15.0.


Revokes an agent token.
You must have the Maintainer or Owner role to use this endpoint.
```
DELETE /projects/:id/cluster_agents/:agent_id/tokens/:token_id
```

Supported attributes:
| Attribute | Type | Required | Description | |————|——————-|———-|—————————————————————————————————————- -| | `id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user. | | `agent_id` | integer | yes | ID of the agent. | | `token_id` | integer | yes | ID of the token. |
Example request:
shell
```
curl --request DELETE \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/tokens/1"
```

## Receptive agents[](https://docs.gitlab.com/api/cluster_agents/#receptive-agents "Permalink")
  * Tier: Ultimate
  * Offering: GitLab Self-Managed


History
  * [Introduced](https://gitlab.com/groups/gitlab-org/-/epics/12180) in GitLab 17.4.


[Receptive agents](https://docs.gitlab.com/user/clusters/agent/#receptive-agents) allow GitLab to integrate with Kubernetes clusters that cannot establish a network connection to the GitLab instance, but can be connected to by GitLab.
### List all URL configurations[](https://docs.gitlab.com/api/cluster_agents/#list-all-url-configurations "Permalink")
Lists all URL configurations for a specified agent.
You must have the Developer, Maintainer, or Owner role to use this endpoint.
```
GET /projects/:id/cluster_agents/:agent_id/url_configurations
```

Supported attributes:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user.
`agent_id` | integer or string | yes | ID of the agent.
Response:
The response is a list of URL configurations with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the URL configuration.
`agent_id` | integer | ID of the agent the URL configuration belongs to.
`url` | string | URL for this URL configuration.
`public_key` | string | (optional) Base64-encoded public key if JWT authentication is used.
`client_cert` | string | (optional) Client certificate in PEM format if mTLS authentication is used.
`ca_cert` | string | (optional) CA certificate in PEM format to verify the agent endpoint.
`tls_host` | string | (optional) TLS host name to verify the server name in agent endpoint.
Example request:
shell
```
curl \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/url_configurations"
```

Example response:
json
```
[
  {
    "id": 1,
    "agent_id": 5,
    "url": "grpcs://agent.example.com:4242",
    "public_key": "..."
  }
]
```

Either `public_key` or `client_cert` is set, but never both.
### Retrieve a URL configuration[](https://docs.gitlab.com/api/cluster_agents/#retrieve-a-url-configuration "Permalink")
Retrieves a single agent URL configuration.
You must have the Developer, Maintainer, or Owner role to use this endpoint.
```
GET /projects/:id/cluster_agents/:agent_id/url_configurations/:url_configuration_id
```

Supported attributes:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user.
`agent_id` | integer | yes | ID of the agent.
`url_configuration_id` | integer | yes | ID of the URL configuration.
Response:
The response is a single URL configuration with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the URL configuration.
`agent_id` | integer | ID of the agent the URL configuration belongs to.
`url` | string | Agent URL for this URL configuration.
`public_key` | string | (optional) Base64-encoded public key if JWT authentication is used.
`client_cert` | string | (optional) Client certificate in PEM format if mTLS authentication is used.
`ca_cert` | string | (optional) CA certificate in PEM format to verify the agent endpoint.
`tls_host` | string | (optional) TLS host name to verify the server name in agent endpoint.
Example request:
shell
```
curl \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/url_configurations/1"
```

Example response:
json
```
{
  "id": 1,
  "agent_id": 5,
  "url": "grpcs://agent.example.com:4242",
  "public_key": "..."
}
```

Either `public_key` or `client_cert` is set, but never both.
### Create a URL configuration[](https://docs.gitlab.com/api/cluster_agents/#create-a-url-configuration "Permalink")
Creates a new URL configuration for an agent.
You must have the Maintainer or Owner role to use this endpoint.
An agent can have only one URL configuration at the time.
```
POST /projects/:id/cluster_agents/:agent_id/url_configurations
```

Supported attributes:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user.
`agent_id` | integer | yes | ID of the agent.
`url` | string | yes | Agent URL for this URL configuration.
`client_cert` | string | no | Client certificate in PEM format if mTLS authentication should be used. Must be provided with `client_key`.
`client_key` | string | no | Client key in PEM format if mTLS authentication should be used. Must be provided with `client_cert`.
`ca_cert` | string | no | CA certificate in PEM format to verify the agent endpoint.
`tls_host` | string | no | TLS host name to verify the server name in agent endpoint.
Response:
The response is the new URL configuration with the following fields:
Attribute | Type | Description
---|---|---
`id` | integer | ID of the URL configuration.
`agent_id` | integer | ID of the agent the URL configuration belongs to.
`url` | string | Agent URL for this URL configuration.
`public_key` | string | (optional) Base64-encoded public key if JWT authentication is used.
`client_cert` | string | (optional) Client certificate in PEM format if mTLS authentication is used.
`ca_cert` | string | (optional) CA certificate in PEM format to verify the agent endpoint.
`tls_host` | string | (optional) TLS host name to verify the server name in agent endpoint.
Example request to create a URL configuration with a JWT token:
shell
```
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --header "Content-Type: application/json" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/url_configurations" \
  --data '{"url":"grpcs://agent.example.com:4242"}'
```

Example response for JWT authentication:
json
```
{
  "id": 1,
  "agent_id": 5,
  "url": "grpcs://agent.example.com:4242",
  "public_key": "..."
}
```

Example request to create a URL configuration using mTLS with a client certificate and key from the files `client.pem` and `client-key.pem`:
shell
```
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --header "Content-Type: application/json" \
  --url "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/url_configurations" \
  --data '{"url":"grpcs://agent.example.com:4242", \
           "client_cert":"'"$(awk -v ORS='\\n' '1' client.pem)"'", \
           "client_key":"'"$(awk -v ORS='\\n' '1' client-key.pem)"'"}'
```

Example response for mTLS:
json
```
{
  "id": 1,
  "agent_id": 5,
  "url": "grpcs://agent.example.com:4242",
  "client_cert": "..."
}
```

If the `client_cert` and `client_key` are not provided, a private-public key pair is generated and JWT authentication is used instead of mTLS.
### Delete a URL configuration[](https://docs.gitlab.com/api/cluster_agents/#delete-a-url-configuration "Permalink")
Deletes an agent URL configuration.
You must have the Maintainer or Owner role to use this endpoint.
```
DELETE /projects/:id/cluster_agents/:agent_id/url_configurations/:url_configuration_id
```

Supported attributes:
Attribute | Type | Required | Description
---|---|---|---
`id` | integer or string | yes | ID or [URL-encoded path of the project](https://docs.gitlab.com/api/rest/#namespaced-paths) maintained by the authenticated user.
`agent_id` | integer | yes | ID of the agent.
`url_configuration_id` | integer | yes | ID of the URL configuration.
Example request:
shell
```
curl --request DELETE --header "PRIVATE-TOKEN: <your_access_token>" "https://gitlab.example.com/api/v4/projects/20/cluster_agents/5/url_configurations/1
```

Was this page helpful?YesNo
Edit this page
  *     * [ Open in Web IDE`.`Quickly and easily edit multiple files. ](https://gitlab.com/-/ide/project/gitlab-org/gitlab/edit/master/-/doc/api/cluster_agents.md)
    * [ View page sourceEdit this file only. ](https://gitlab.com/gitlab-org/gitlab/-/blob/master/doc/api/cluster_agents.md)
    * [ Create an issueSuggest improvements. ](https://gitlab.com/gitlab-org/gitlab/-/issues/new?issuable_template=Documentation)


  * [List all agents](https://docs.gitlab.com/api/cluster_agents/#list-all-agents)
  * [Retrieve an agent](https://docs.gitlab.com/api/cluster_agents/#retrieve-an-agent)
  * [Create an agent](https://docs.gitlab.com/api/cluster_agents/#create-an-agent)
  * [Delete an agent](https://docs.gitlab.com/api/cluster_agents/#delete-an-agent)
  * [List all agent tokens](https://docs.gitlab.com/api/cluster_agents/#list-all-agent-tokens)
  * [Retrieve an agent token](https://docs.gitlab.com/api/cluster_agents/#retrieve-an-agent-token)
  * [Create an agent token](https://docs.gitlab.com/api/cluster_agents/#create-an-agent-token)
  * [Revoke an agent token](https://docs.gitlab.com/api/cluster_agents/#revoke-an-agent-token)
  * [Receptive agents](https://docs.gitlab.com/api/cluster_agents/#receptive-agents)
  * [List all URL configurations](https://docs.gitlab.com/api/cluster_agents/#list-all-url-configurations)
  * [Retrieve a URL configuration](https://docs.gitlab.com/api/cluster_agents/#retrieve-a-url-configuration)
  * [Create a URL configuration](https://docs.gitlab.com/api/cluster_agents/#create-a-url-configuration)
  * [Delete a URL configuration](https://docs.gitlab.com/api/cluster_agents/#delete-a-url-configuration)


[![GitLab Docs logo](https://docs.gitlab.com/gitlab-logo-footer.svg)](https://docs.gitlab.com/)
  * [Facebook](https://www.facebook.com/gitlab)
  * [LinkedIn](https://www.linkedin.com/company/gitlab-com)
  * [Twitter](https://twitter.com/gitlab)
  * [YouTube](https://www.youtube.com/channel/UCnMGQ8QHMAnVIsI3xJrihhg)

[![Creative Commons License](https://docs.gitlab.com/by-sa.svg)](https://creativecommons.org/licenses/by-sa/4.0/)
Company
  * [About GitLab](https://about.gitlab.com/company/)
  * [View pricing](https://about.gitlab.com/pricing/)
  * [Try GitLab for free](https://about.gitlab.com/free-trial/)


Feedback
  * [View page source](https://gitlab.com/gitlab-org/gitlab/-/blob/master/doc/api/cluster_agents.md)
  * [Edit in Web IDE](https://gitlab.com/-/ide/project/gitlab-org/gitlab/edit/master/-/doc/api/cluster_agents.md)
  * [Contribute to GitLab](https://about.gitlab.com/community/contribute/)
  * [Suggest updates](https://gitlab.com/gitlab-org/gitlab/-/issues/new?issuable_template=Documentation)


Help & Community
  * [Get certified](https://university.gitlab.com/pages/certifications)
  * [Get support](https://about.gitlab.com/support/)
  * [Post on the GitLab forum](https://forum.gitlab.com/new-topic?title=topic%20title&body=topic%20body&tags=docs-feedback)


Resources
  * [Terms](https://about.gitlab.com/terms/)
  * [Privacy statement](https://about.gitlab.com/privacy/)
  * [Use of generative AI](https://docs.gitlab.com/legal/use_generative_ai/)
  * [Acceptable use of user licenses](https://docs.gitlab.com/legal/licensing_policy/)
  * Cookie Preferences


![](https://cdn.bizible.com/ipv?_biz_r=&_biz_h=800054037&_biz_u=10503924d6784ad3f2d352558587a67a&_biz_l=https%3A%2F%2Fdocs.gitlab.com%2Fapi%2Fcluster_discovery%2F&_biz_t=1772174229199&_biz_i=Cluster%20discovery%20API%20\(certificate-based\)%20\(deprecated\)%20%7C%20GitLab%20Docs&_biz_n=21&rnd=904678&cdn_o=a&_biz_z=1772174229330)![](https://cdn.bizible.com/ipv?_biz_r=&_biz_h=800054037&_biz_u=10503924d6784ad3f2d352558587a67a&_biz_l=https%3A%2F%2Fdocs.gitlab.com%2Fapi%2Fcluster_agents%2F&_biz_t=1772174229329&_biz_i=Kubernetes%20agent%20API%20%7C%20GitLab%20Docs&_biz_n=22&rnd=63884&cdn_o=a&_biz_z=1772174229330)
![Company Logo](https://cdn.cookielaw.org/logos/aa14a5c8-79e3-442a-8177-464ad850b19d/e46c1d0d-1f66-481f-bc06-5427671431da/253e6fee-c4c0-4b60-bc35-79cdae5dda32/gitlab-logo-100.png)
## Privacy Preference Center
## Privacy Preference Center
  * ### Your Privacy
  * ### Strictly Necessary Cookies
  * ### Functionality Cookies
  * ### Performance and Analytics Cookies
  * ### Targeting and Advertising Cookies
  * ### Ad User Data
  * ### Ad Personalization


#### Your Privacy
When you visit any website, it may store or retrieve information on your browser, mostly in the form of cookies. This information might be about you, your preferences or your device and is mostly used to make the site work as you expect it to. The information does not usually directly identify you, but it can give you a more personalized web experience. Because we respect your right to privacy, you can choose not to allow some types of cookies. Click on the different category headings to find out more and change our default settings. However, blocking some types of cookies may impact your experience of the site and the services we are able to offer.
[Cookie Policy](https://about.gitlab.com/privacy/cookies/)
**User ID:** 42fad8d5-ed56-4786-8d74-3c72635252d2
_This User ID will be used as a unique identifier while storing and accessing your preferences for future._
**Timestamp:** --
#### Strictly Necessary Cookies
Always Active
These cookies are necessary for the website to function and cannot be switched off in our systems. They are usually only set in response to actions made by you which amount to a request for services, such as setting your privacy preferences, enabling you to securely log into the site, filling in forms, or using the customer checkout. GitLab processes any personal data collected through these cookies on the basis of our legitimate interest.
Cookies Details
#### Functionality Cookies
Functionality Cookies
These cookies enable helpful but non-essential website functions that improve your website experience. By recognizing you when you return to our website, they may, for example, allow us to personalize our content for you or remember your preferences. If you do not allow these cookies then some or all of these services may not function properly. GitLab processes any personal data collected through these cookies on the basis of your consent
Cookies Details
#### Performance and Analytics Cookies
Performance and Analytics Cookies
These cookies allow us and our third-party service providers to recognize and count the number of visitors on our websites and to see how visitors move around our websites when they are using it. This helps us improve our products and ensures that users can easily find what they need on our websites. These cookies usually generate aggregate statistics that are not associated with an individual. To the extent any personal data is collected through these cookies, GitLab processes that data on the basis of your consent.
Cookies Details
#### Targeting and Advertising Cookies
Targeting and Advertising Cookies
These cookies enable different advertising related functions. They may allow us to record information about your visit to our websites, such as pages visited, links followed, and videos viewed so we can make our websites and the advertising displayed on it more relevant to your interests. They may be set through our website by our advertising partners. They may be used by those companies to build a profile of your interests and show you relevant advertisements on other websites. GitLab processes any personal data collected through these cookies on the basis of your consent.
Cookies Details
#### Ad User Data
Ad User Data
Sets consent for sending user data to Google for advertising purposes.
Cookies Details
#### Ad Personalization
Ad Personalization
Sets consent for personalized advertising.
Cookies Details
Back Button
### Cookie List
Filter Button
Consent Leg.Interest
checkbox label label
checkbox label label
checkbox label label
Clear
  * checkbox label label


Apply Cancel
Confirm My Choices
Allow All
[![Powered by Onetrust](https://cdn.cookielaw.org/logos/static/powered_by_logo.svg)](https://www.onetrust.com/products/cookie-consent/)
